#ifndef TEMPSET_H
#define TEMPSET_H

#include <map>
#include <algorithm>
using namespace std;

template<class T> class TempSet;

template<class T> class TSiter{
	private:
		typedef multimap<T,int>::iterator ait;	// iteratore ausiliario
		typedef const T& reference_type;
		TempSet<T>* cont;	// container corrente
		ait curr;	// itaratore ausiliario corrente

	public:
		TSiter() {};
		TSiter(TempSet<T>& x, ait v): cont(&x), curr(v) {};
		TSiter operator++();
		template<class C> friend bool operator==(const TSiter<C>& sx, const TSiter<C>& dx);
		reference_type operator*() const;
};

template<class T> class TempSet{
	private:
		friend TSiter<T> TSiter<T>::operator++();
		typedef TSiter<T> iterator;
		typedef multimap<T,int>::iterator ait;
		multimap<T,int> TS;
		int count;
		static const int clean=50;
		void purge();
	public:
		iterator end();
		iterator find(const T&);
		pair<iterator, iterator> equal_range(const T&);
		void insert(const T&, int=0);
};

template<class C> bool old(const typename TSiter<C>::ait& iter){
	return (iter->second)<100;
}

template<class C> class o_old : public unary_function< pair<const C,int>, bool>{
	public:
		bool operator()(pair<const C,int> cop) {
			return cop.second<100;
		}
};

template<class T> TSiter<T>::reference_type TSiter<T>::operator*() const{
	return curr->first;
}

template<class T> TSiter<T> TSiter<T>::operator++(){
	ait it;
	for(it=++curr; it!=cont->TS.end() && old<T>(it); ++it);
	curr=it;
	
}

template<class T> bool operator==(const TSiter<T>& sx, const TSiter<T>& dx){
	return sx.cont==dx.cont && sx.curr==dx.curr;
}

template<class T> TempSet<T>::iterator TempSet<T>::end(){
	return TSiter<T>(*this, TS.end());
}

template<class T> TempSet<T>::iterator TempSet<T>::find(const T& what){
	pair<ait,ait> coppia=TS.equal_range(what);
	ait ret;
	for(ret=coppia.first; old<T>(ret) && ret!=coppia.second; ++ret);
	return ret==coppia.second? TSiter<T>(*this, TS.end()): TSiter<T>(*this, ret);
}

template<class T> void TempSet<T>::purge(){
	multimap< T,int > purged;
	remove_copy_if(TS.begin(), TS.end(), inserter(purged,purged.end()), o_old<T>() );
	TS=purged;		 
}

template<class T> pair<TempSet<T>::iterator,TempSet<T>::iterator> TempSet<T>::equal_range(const T& what){
	if (++count%clean==0)
		purge();
	pair<ait,ait> coppia=TS.equal_range(what);

	ait f;
	for(f=coppia.first; old<T>(f) && f!=coppia.second; ++f);
	iterator fi,la;
	if (f==coppia.second){
		fi=la=TSiter<T>(*this, TS.end());
	} else {
		fi=TSiter<T>(*this, f);
		ait l=coppia.second;
		while (l!=TS.end() && old<T>(l))
			++l;
		la=TSiter<T>(*this, l);
	}

	return make_pair(fi,la);
}

template<class T> void TempSet<T>::insert(const T& what, int time=0){
	TS.insert(make_pair(what,time));
}

#endif
